using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Animation
{
 public partial class Form1 : Form
 {
  public Form1()
  {
   InitializeComponent();
  }

  private void Form1_Load(object sender, EventArgs e)
  {
   pbFond.Visible = false;
   Width = WImage; Height = HImage;
   WCS = ilCS.ImageSize.Width;
   HCS = ilCS.ImageSize.Height;

   this.SetStyle(ControlStyles.AllPaintingInWmPaint, true);
   this.SetStyle(ControlStyles.DoubleBuffer, true);

   rndm = new Random();
   for (int i = 0; i < 5; i++)
   {
    CS oCS = new CS();
    oCS.pos.X = rndm.Next() % (WImage - WCS);
    oCS.pos.Y = rndm.Next() % (HImage - HCS);
    oCS.delta.Width = 1 + rndm.Next() % 10;
    oCS.delta.Height = 1 + rndm.Next() % 10;
    tCS.Add(oCS);
   }
   timer1.Interval = 1000 / N;
   timer1.Enabled = true;
  }

  int N = 10;                                // Nombre d'affichage par seconde
  Random rndm;
  int WImage = 640, HImage = 480;              // Largeur et hauteur de l'image de fond
  int WCS, HCS;                            // Largeur et hauteur d'un sprite
  struct CS
  {
   public Point pos;
   public Size delta;
  }
  ArrayList tCS = new ArrayList();

  private void timer1_Tick(object sender, EventArgs e)
  {
   for (int i = 0; i < tCS.Count; i++)
   {
    CS oCS = (CS)tCS[i];
    oCS.pos.X += oCS.delta.Width;
    if (oCS.pos.X < 0 || oCS.pos.X >= ClientRectangle.Width - WCS) oCS.delta.Width *= -1;
    oCS.pos.Y += oCS.delta.Height;
    if (oCS.pos.Y < 0 || oCS.pos.Y >= ClientRectangle.Height - HCS) oCS.delta.Height *= -1;
    tCS[i] = oCS;
   }
   Invalidate(false);
  }

  private void Form1_Paint(object sender, PaintEventArgs e)
  {
   e.Graphics.DrawImage(pbFond.Image, 0, 0, WImage, HImage);
   foreach (CS o in tCS) ilCS.Draw(e.Graphics, o.pos.X, o.pos.Y, WCS, HCS, 0);
  }

  private void miAjouterFigurine_Click(object sender, EventArgs e)
  {
   CS oCS = new CS();
   oCS.pos.X = rndm.Next() % (WImage - WCS);
   oCS.pos.Y = rndm.Next() % (HImage - HCS);
   oCS.delta.Width = 1 + rndm.Next() % 10;
   oCS.delta.Height = 1 + rndm.Next() % 10;
   tCS.Add(oCS);  
  }

  private void retirerUneFigurineToolStripMenuItem_Click(object sender, EventArgs e)
  {
   int n = tCS.Count;
   if (n > 0) tCS.RemoveAt(n - 1);  
  }

  private void miPlusVite_Click(object sender, EventArgs e)
  {
   N++;
   timer1.Interval = 1000 / N;  
  }

  private void miMoinsVite_Click(object sender, EventArgs e)
  {
   if (N > 0)
   {
    N--;
    timer1.Interval = 1000 / N;
   }  
  }

  private void miNombre_DropDownOpened(object sender, EventArgs e)
  {
   miRetirerFigurine.Enabled = tCS.Count != 0;   
  }

  private void miVitesse_DropDownOpened(object sender, EventArgs e)
  {
   miMoinsVite.Enabled = N > 1;   
  }
		

 }
}